import { Base, Type } from "./type";
import { UIElementPropertyId } from "./UIElementPropertyId";
import { NativeUIBuiltInEvents } from "./NativeUIBuiltInEvents";
import { NativeUIBuiltInProperties } from "./NativeUIBuiltInProperties";
import { NativeUIComponentHorizontalAlignment } from "./NativeUIComponentHorizontalAlignment";
import { NativeUIComponentVerticalAlignment } from "./NativeUIComponentVerticalAlignment";
import { Size } from "./Size";
import { NativeUIComponentBuiltInType } from "./NativeUIComponentBuiltInType";
import { BaseControlTheme } from "./BaseControlTheme";
import { Brush } from "./Brush";
import { Thickness } from "./Thickness";
import { CornerRadius } from "./CornerRadius";
import { Transform } from "./Transform";
import { INativeUIElementFactory } from "./INativeUIElementFactory";
import { NativeUIElementFactoryFlavor } from "./NativeUIElementFactoryFlavor";
/**
 * @hidden
 */
export interface INativeUIElementBridge {
    getMethodTarget(a: any): any;
    getTargetForProperty(a: UIElementPropertyId, b: any): any;
    addHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    removeHandler(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    getValue(a: any, b: NativeUIBuiltInProperties): any;
    setValue(a: any, b: NativeUIBuiltInProperties, c: any): void;
    getTargetForBuildInProperty(a: any, b: NativeUIBuiltInProperties): any;
    getTargetForBuildInEvent(a: any, b: NativeUIBuiltInEvents): any;
    getHorizontalAlignment(a: any): NativeUIComponentHorizontalAlignment;
    setHorizontalAlignment(a: any, b: NativeUIComponentHorizontalAlignment): void;
    getVerticalAlignment(a: any): NativeUIComponentVerticalAlignment;
    setVerticalAlignment(a: any, b: NativeUIComponentVerticalAlignment): void;
    getDesiredSize(a: any, b: Size): Size;
}
/**
 * @hidden
 */
export declare let INativeUIElementBridge_$type: Type;
/**
 * @hidden
 */
export declare class NativeUIComponent extends Base {
    static $t: Type;
    au(a: Size): Size;
    y: any;
    protected get_e(): NativeUIComponentBuiltInType;
    get e(): NativeUIComponentBuiltInType;
    protected get w(): any;
    private static h;
    static ab(a: INativeUIElementFactory): void;
    private static a;
    static ac(a: any, b: NativeUIComponentBuiltInType, c: NativeUIElementFactoryFlavor, d: (arg1: any) => void): void;
    static ad(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    static ae(a: any, b: NativeUIComponentBuiltInType[], c: NativeUIElementFactoryFlavor[], d: (arg1: any[]) => void): void;
    static af(a: any, b: NativeUIComponentBuiltInType[], c: (arg1: any[]) => void): void;
    static ag(a: any, b: NativeUIComponentBuiltInType, c: NativeUIElementFactoryFlavor, d: (arg1: any) => void): void;
    static ah(a: any, b: NativeUIComponentBuiltInType, c: (arg1: any) => void): void;
    d: INativeUIElementBridge;
    x: any;
    protected v(a: UIElementPropertyId): any;
    protected s(a: UIElementPropertyId): any;
    protected am(a: UIElementPropertyId, b: any): void;
    protected q(a: NativeUIBuiltInProperties): any;
    protected ak(a: NativeUIBuiltInProperties, b: any): void;
    protected z(a: NativeUIBuiltInEvents, b: any): void;
    protected aa(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    protected ai(a: NativeUIBuiltInEvents, b: any): void;
    protected aj(a: any, b: NativeUIComponent, c: NativeUIBuiltInEvents, d: any): void;
    protected r(a: any, b: NativeUIBuiltInProperties): any;
    protected al(a: any, b: NativeUIBuiltInProperties, c: any): void;
    protected u(a: NativeUIBuiltInProperties): any;
    protected t(a: NativeUIBuiltInEvents): any;
    get p(): number;
    set p(a: number);
    get j(): number;
    set j(a: number);
    get l(): number;
    set l(a: number);
    get c(): BaseControlTheme;
    set c(a: BaseControlTheme);
    get ao(): Brush;
    set ao(a: Brush);
    get ap(): Brush;
    set ap(a: Brush);
    get av(): Thickness;
    set av(a: Thickness);
    get an(): CornerRadius;
    set an(a: CornerRadius);
    get ax(): Thickness;
    set ax(a: Thickness);
    get aq(): Brush;
    set aq(a: Brush);
    get i(): number;
    set i(a: number);
    get k(): number;
    set k(a: number);
    get o(): number;
    set o(a: number);
    get aw(): Thickness;
    set aw(a: Thickness);
    get at(): Transform;
    set at(a: Transform);
    get as(): Brush;
    set as(a: Brush);
    get ar(): Brush;
    set ar(a: Brush);
    get n(): number;
    set n(a: number);
    get b(): number[];
    set b(a: number[]);
    get m(): number;
    set m(a: number);
    get f(): NativeUIComponentHorizontalAlignment;
    set f(a: NativeUIComponentHorizontalAlignment);
    get g(): NativeUIComponentVerticalAlignment;
    set g(a: NativeUIComponentVerticalAlignment);
}
